"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = __importStar(require("lodash"));
var src_1 = require("../src");
describe("Search", function () {
    var search;
    beforeEach(function () { return (search = new src_1.Search()); });
    // TODO - non-English
    // TODO - avoid regex injection
    // TODO - more score if closer to start of string
    // TODO - more score if covers more of string
    // TODO - multi-part terms
    // TODO - results in markdown
    _.each([
        ["hell", "hello", 3, "*hell*o"],
        ["world", "hello world", 2, "hello *world*"],
        ["ell", "hello", 1, "h*ell*o"],
        ["help", "hello", 0, "hello"],
        ["Hell", "hello", 0, "hello"],
        ["hell", "Hello", 3, "*Hell*o"]
    ], function (_a) {
        var searchTerm = _a[0], str = _a[1], expectedScore = _a[2], marked = _a[3];
        return it("should search(" + searchTerm + ", " + str + ") = " + expectedScore + ", " + marked, function () {
            var res = search.term(searchTerm).in(str);
            expect(res.score).toBe(expectedScore);
            expect(res.marked).toEqual(marked);
        });
    });
    function mark(str, spans) {
        var b = "<1>";
        var a = "</1>";
        var ret = "";
        var p = 0;
        var normalized = _.map(spans, function (span) { return (_.isNumber(span) ? [span, span + 1] : span); });
        _.each(normalized, function (span) {
            ret = ret + ("" + str.substring(p, span[0]) + b + str.substring(span[0], span[1]) + a);
            p = span[1];
        });
        ret = ret + str.substring(p);
        return ret;
    }
    it("should mark", function () {
        expect(mark("hello world", [[1, 3], 7])).toEqual("h<1>el</1>lo w<1>o</1>rld");
        expect(mark("hello world", [])).toEqual("hello world");
        expect(mark("hello world", [7])).toEqual("hello w<1>o</1>rld");
    });
});
